
#include <stdio.h>
#include <assert.h>

#include <caml/mlvalues.h>
#include <caml/memory.h>


value increment_t(value t) {
  CAMLparam1(t);
  CAMLlocal1(result);

  if(Is_long(t)) {

    /* result now holds the representation of Empty */
    result = Val_int(0);

  } else if(Tag_val(t) == 0) { /* t = Single */

      int v = Int_val(Field(t,0));
      
      /* v_incr will only hold an unboxed value, so we don't have to
	 declare it with CAMLlocal* */
      value v_incr = Val_int(v + 1);

      /* Allocate a new block with size 1 and tag 0 (same tag that we
	 matched above) */
      result = caml_alloc(1, 0);
      
      Store_field(result,0,v_incr); /* store v_incr in field 0 of result */
      
    } else if(Tag_val(t) == 1) { /* t = Double */

      int v = Int_val(Field(t,1));
      
      /* v_incr will only hold an unboxed value, so we don't have to
	 declare it with CAMLlocal* */
      value v_incr = Val_int(v + 1);
      
      /* Allocate a new block with size 2 and tag 1 (same tag that we
	 matched above) */
      result = caml_alloc(2,1);
      
      /* Store the first field of t in the first field of result */
      Store_field(result,0,Field(t,0));
      Store_field(result,1,v_incr); /* store v_incr in field 1 of result */
      
    } else {
      fprintf(stderr,"you updated the t but forgot to update the C code!\n");
      assert(0);
    }

    CAMLreturn(result);
}
